
#include <jni.h>      /* Java Native Interface headers */
#include "StandardBarrierOptPrice.h"   /* Auto-generated header created by javah -jni */
#include <nag.h>      /* NAG C Library headers */
#include <nags.h>

/* Our C definition of the function s30fac declared in EuropeanOptPrice.java */
JNIEXPORT jint JNICALL Java_StandardBarrierOptPrice_s30fac
  (JNIEnv *env, jobject obj, jchar calput, jstring type, jint m, jint n,
   jdoubleArray x, jdouble s, jdouble h, jdouble k, jdoubleArray t, 
   jdouble sigma, jdouble r, jdouble q, jdoubleArray p)
{ 
  static NagError fail;
  Nag_CallPut iput;
  Nag_Barrier itype;
  Nag_OrderType order;

  /* First extract the arrays and string from Java */
  jdouble *xpt, *tpt, *ppt;
  jboolean isCopy;
  const char *typept;

  xpt = (*env)->GetDoubleArrayElements(env, x, &isCopy);
  tpt = (*env)->GetDoubleArrayElements(env, t, &isCopy);
  ppt = (*env)->GetDoubleArrayElements(env, p, &isCopy);
  typept = (*env)->GetStringUTFChars(env, type, 0);

  /* Java stores arrays in row order */
  order = Nag_RowMajor;

  /* Convert calput into Nag_CallPut */
  if (calput == 'P')
    {
      iput = Nag_Put;
    }
  else if (calput == 'C')
    {
      iput = Nag_Call;
    }

  if (!strcmp(typept, "DI"))
    {
      itype = Nag_DownandIn;
    }
  else if (!strcmp(typept, "DO"))
    {
      itype = Nag_DownandOut;
    }
  else if (!strcmp(typept, "UI"))
    {
      itype = Nag_UpandIn;
    }
  else if (!strcmp(typept, "UO"))
    {
      itype = Nag_UpandOut;
    }

  /* Free up the Java string argument so we don't leak memory. */
  (*env)->ReleaseStringUTFChars(env, type, typept);
  
  /* Call s30fac */
  fail.print = Nag_FALSE;
  s30fac(order, iput, itype, m, n, xpt, s, h, k, tpt, sigma, r, q, ppt,
         &fail);

  /* Release the array elements back to Java */
  (*env)->ReleaseDoubleArrayElements(env, x, xpt, 0);
  (*env)->ReleaseDoubleArrayElements(env, t, tpt, 0);
  (*env)->ReleaseDoubleArrayElements(env, p, ppt, 0);
 
  return fail.code;
}
